package com.steria.digitalsignature.properties;

import java.io.IOException;
import java.util.Properties;

import com.steria.digitalsignature.config.*;

/**
 * @author cvila
 * Cont constants de configuraci que permeten referenciar les claus del fitxer properties que configura laplicaci. 
 * file.properties: Cont els valors especfics de la informaci que hem dutilitzar en cada cas, sobre tot conte valors ms subsetibles a canviar durant el temps que no la clase de ConstantsApplicacio. Per exemple valors de lubicaci dels fitxers de proves, les diferents urls de treball i proves o be les claus (keys) dalguns missatges de retorn especifics que poden canviar tamb. 
 */
public final class ConfigProperties
{
    private static String PROPERTIES_FILE = "com/steria/digitalsignature/properties/file.properties"; 
    //private static String PROPERTIES_FILE = "file.properties";
    
    public static String PROP_PROXY_HOST = "ProxyHost"; 
    public static String PROP_PROXY_PORT = "ProxyPort"; 
    public static String PROP_TRUST_STORE_PATH = "TrustStorePath"; 
    public static String PROP_TRUST_STORE_TYPE = "TrustStoreType"; 
    public static String PROP_TRUST_STORE_PASSWORD = "TrustStorePassword"; 
    public static String PROP_KEYSTORE_PATH = "KeyStorePath"; 
    public static String PROP_KEYSTORE_TYPE = "KeyStoreType"; 
    public static String PROP_KEYSTORE_PASSWORD = "KeyStorePassword"; 
    public static String PROP_PKGS = "pkgs"; 
    public static String PROP_CERT_FILE = "CertFile"; 
    public static String PROP_CERT_FILE_REVOKED = "RevokedCertFile"; 
    public static String PROP_CERT_FILE_EXPIRED = "ExpiredCertFile"; 
    public static String PROP_SOAP_URL = "SoapUrl"; 
    public static String PROP_SOAP_DSS_PDF_URL = "SoapDssPdfUrl"; 
    public static String PROP_PREF1_NAMESPACE_KEY = "Pref1NamespaceKey"; 
    public static String PROP_PREF1_NAMESPACE_VALUE = "Pref1NamespaceValue"; 
    public static String PROP_PREF2_NAMESPACE_KEY = "Pref2NamespaceKey"; 
    public static String PROP_PREF2_NAMESPACE_VALUE = "Pref2NamespaceValue"; 
    public static String PROP_BASE64_CMS_SIGNATURA_TYPE = "Base64CMSSignatureType"; 
    public static String PROP_BASE64_CADES_SIGNATURA_TYPE = "Base64CADESSignatureType"; 
    public static String PROP_BASE64_XADES_SIGNATURA_TYPE = "Base64XADESSignatureType"; 
    public static String PROP_BASE64_XML_DSIGN_SIGNATURA_TYPE = "Base64XmlDsignSignatureType"; 
    public static String PROP_ALGORITHM_SHA1_URL = "AlgorithmSha1Url"; 
    // Defaults test files
    // Signature CMS
    public static String PROP_SIGNATURE_CMS_FILE = "SignatureCMSfile"; 
    public static String PROP_SIGNED_CMS_FILE = "SignedCMSfile"; 
    // Signature CMS detached document
    public static String PROP_SIGNATURE_CMS_DETACHED_FILE = "SignatureCMSdetachedFile"; 
    public static String PROP_DATA_CMS_DETACHED_FILE = "DataCMSdetachedFile"; 
    // Signature CMS detached hash document
    public static String PROP_SIGNATURE_CMS_DETACHED_HASH_FILE = "SignatureCMSdetachedHashFile"; 
    public static String PROP_DATA_CMS_DETACHED_HASH_FILE = "DataCMSdetachedHashFile"; 
    // Signature PDF
    public static String PROP_SIGNED_PDF_FILE = "SignedPDFfile"; 
    // Timestamp certificate files
    public static String PROP_TIMESTAMP_CERTIFICATE_FILE = "TimestampCertificateFile"; 
    public static String PROP_TIMESTAMP_DIGEST_FILE = "TimestampDigestFile"; 
    public static String PROP_TIMESTAMP_DATA_FILE = "TimestampDataFile"; 
    // Returned message OK
    public static String PROP_RESULT_MAJOR = "ResultMajor"; 
    public static String PROP_RESULT_MAJOR_EXPECTED = "ResultMajorExpected"; 
    
    private static ConfigProperties instance   = null;
    
    private Properties properties = null;

    private ConfigProperties()
    {
    }

    public static ConfigProperties getInstance(boolean reload)
    {
        if ((instance == null) || (reload))
        {
            instance = new ConfigProperties();
            instance.reload();
        }
        return instance;
    }

    public String getProperty(String key)
    {
        return properties.getProperty(key);
    }

    public void reload()
    {
        //properties = new Properties();
        //InputStream is = null;
        try
        {
            properties = CommonUtils.getContextConfig(PROPERTIES_FILE);
            //is = ClassLoader.getSystemResourceAsStream(PROPERTIES_FILE);
            //properties.load(is);
        }
        catch (IOException e)
        {
            System.out.println("WARN: " + e.getMessage()); 
        }
        /*
        finally
        {
            try
            {
                if (is != null) is.close();
            }
            catch (IOException ioe)
            {
            }
        }
        */
    }

}