/**
 * 
 */
package com.steria.digitalsignature.ejbs;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

import com.steria.digitalsignature.core.CreacioSegellDeTemps;
import com.steria.digitalsignature.core.ValidacioCertificat;
import com.steria.digitalsignature.core.ValidacioSegellDeTemps;
import com.steria.digitalsignature.core.ValidacioSignatura;
import com.steria.digitalsignature.core.ValidacioSignaturaPDF;
import com.steria.digitalsignature.vo.DigitalSignatureContentVo;


/**
 *
 * <!-- begin-user-doc -->
 * A generated session bean
 * <!-- end-user-doc -->
 * 
 * <!-- begin-xdoclet-definition --> 
 * @ejb.bean name="ProveidorSignatura"	
 *           description="A session bean named ProveidorSignatura"
 *           display-name="ProveidorSignatura"
 *           jndi-name="ejb/ProveidorSignatura"
 *           type="Stateless" 
 *           transaction-type="Container"
 *           view-type = "all"
 * 
 * @ejb.permission role-name="dptt-serviceuser,dptt-serviceadmin,dptt-webuser,dptt-webadmin" 
 *  
 * @ejb.security-role-ref
 *   role-name="dptt-serviceadmin"
 *   role-link="dptt-serviceadmin"
 * @ejb.security-role-ref
 *   role-name="dptt-serviceuser"
 *   role-link="dptt-serviceuser"
 * @ejb.security-role-ref
 *   role-name="dptt-webadmin"
 *   role-link="dptt-webadmin"      
 * @ejb.security-role-ref
 *   role-name="dptt-webuser"
 *   role-link="dptt-webuser"
 *   
 * @ejb.interface 
 *           service-endpoint-class="com.steria.digitalsignature.ejbs.ProveidorSignaturaEndpoint"
 *           
 * @jboss.port-component 
 *           auth-method="BASIC" 
 *           name="ProveidorSignaturaEndpoint"  

 * @generated
 */

public abstract class ProveidorSignaturaBean implements javax.ejb.SessionBean
{

    /** 
     *
     * <!-- begin-xdoclet-definition --> 
     * @ejb.create-method view-type="both"
     * <!-- end-xdoclet-definition --> 
     * @generated
     *
     * //TODO: Must provide implementation for bean create stub
     */
    public void ejbCreate()
    {
    }

    /**
     * Cal, com a minim, definir com entrada 
     * vo.setX509Certificate(byte[]) amb el array de bytes binary
     * corresponent al certificat.
     * 
     * @return DigitalSignatureContentVo on  els atributs
     *      <ul>
     *      <li>isProcessOk() = Rebut un ResultMajor "Succes"</li>
     *      <li>getMsg.get("dss:ResultMajor") : Texte de resultat</li>
     *      <li>getMsg.get("dss:ResultMinor") : Texte de resultat complementari opcional</li>
     *      </ul>
     * 
     * @throws Exception 
     * @ejb.interface-method view-type="all" <!-- end-xdoclet-definition -->
     * @generated
     * 
     */
    public DigitalSignatureContentVo validateCertificatX509(DigitalSignatureContentVo vo)
    throws Exception
    {
        ValidacioCertificat validarCertificat = new ValidacioCertificat();
        if (vo == null)
        {
            vo = validarCertificat.createDefaultVO();
        }
        validarCertificat.validar(vo);
        return vo;
    }
    
    /**
     * 
     * <!-- begin-xdoclet-definition -->
     * @throws Exception 
     * @ejb.interface-method view-type="all" <!-- end-xdoclet-definition -->
     * @generated
     * 
     */
    public DigitalSignatureContentVo validateSignatureCMSdetached(DigitalSignatureContentVo vo)
    throws Exception
    {
        ValidacioSignatura validarSign = new ValidacioSignatura(ValidacioSignatura.TipusSignatura.CMSdetached);
        if (vo == null)
        {
            vo = validarSign.createDefaultVO();
        }
        validarSign.validar(vo);
        return vo;
    }
    
    /**
     * <!-- begin-user-doc -->
     *  
     * <!-- end-user-doc -->
     * <!-- begin-xdoclet-definition -->
     * @throws Exception 
     * @ejb.interface-method view-type="all" <!-- end-xdoclet-definition -->
     * @generated
     * 
     */
    public DigitalSignatureContentVo validateSignatureCMSdetachedHashDocument(DigitalSignatureContentVo vo)
    throws Exception
    {
        ValidacioSignatura validarSign = new ValidacioSignatura(ValidacioSignatura.TipusSignatura.CMSdetachedHashDoc);
        if (vo == null)
        {
            vo = validarSign.createDefaultVO();
        }
        validarSign.validar(vo);
        return vo;
    }
    
    /**
     * <!-- begin-user-doc -->
     *  
     * <!-- end-user-doc -->
     * <!-- begin-xdoclet-definition -->
     * @throws Exception 
     * @ejb.interface-method view-type="all" <!-- end-xdoclet-definition -->
     * @generated
     * 
     */
    public DigitalSignatureContentVo validateSignatureCMSdetachedDocument(DigitalSignatureContentVo vo)
    throws Exception
    {
        ValidacioSignatura validarSign = new ValidacioSignatura(ValidacioSignatura.TipusSignatura.CMSdetachedDoc);
        if (vo == null)
        {
            vo = validarSign.createDefaultVO();
        }
        validarSign.validar(vo);
        return vo;
    }

    /**
     * <!-- begin-user-doc -->
     *  
     * <!-- end-user-doc -->
     * <!-- begin-xdoclet-definition -->
     * @throws Exception 
     * @ejb.interface-method view-type="all" <!-- end-xdoclet-definition -->
     * @generated
     * 
     */
    public DigitalSignatureContentVo validateSignaturePDF(DigitalSignatureContentVo vo)
    throws Exception
    {
        ValidacioSignaturaPDF validarSign = new ValidacioSignaturaPDF();
        if (vo == null)
        {
            vo = validarSign.createDefaultVO();
        }
        validarSign.validar(vo);
        return vo;
    }
    
    /**
     * Cal, com a minim, establir el camp vo.<b>setData</b> amb el digest SHA-1 de les dades 
     * que es volen signar per crear la signatura que inclou informaci de temps.
     * <br>
     * Si no s'informa el certificat a emprar (vo.<b>certificate</b>) es fara servir el configurat
     * per defecte a la plataforma (certificat de seguell de temps de catcert).
     * 
     * @throws Exception 
     * @ejb.interface-method view-type="all"
     * @return DigitalSignatureContentVo on  els atributs
     *      <ul>
     *      <li>isProcessOk() = Rebut un ResultMajor "Succes"</li>
     *      <li>getMsg.get("dss:ResultMajor") : Texte de resultat</li>
     *      <li>getMsg.get("dss:ResultMinor") : Texte de resultat complementari opcional</li>
     *      </ul>
     *      Si el process es correcte, rebem, addicionalment, aquests dos parmetres:      
     *      <ul><li>getAtributs().get("dss:SignatureObject") : conte el XML del objecte Signatura retornat per PSIS,
     *      complert, necessari per validacions de timestamp.</li> 
     *      <li>getSignature(): conte la signatura realitzada  en format byte[] binari.</li>
     *      </ul>
     *  
     * @generated
     * 
     */
    public DigitalSignatureContentVo createTimestamp(DigitalSignatureContentVo vo)
    throws Exception
    {
        CreacioSegellDeTemps crearST = new CreacioSegellDeTemps();
        if (vo == null)
        {
            vo = crearST.createDefaultVO();
        }
        crearST.crear(vo);
        return vo;
    }
    
    /**
     * Cal, com a minim definir al vo el camp <b>inlineXML</b> 
     * La part de seguell de temps "<dss:Timestamp ...>...</dss:Timestamp>" 
     * que es el valor de comparaci referencia 
     * i el digest SHA-1 del document a validar (camp vo.<b>data</b>).
     * 
     * @throws Exception 
     * @ejb.interface-method view-type="all" 
     * @generated
     * 
     */
    public DigitalSignatureContentVo validateTimestamp(DigitalSignatureContentVo vo)
    throws Exception
    {
        ValidacioSegellDeTemps validarST = new ValidacioSegellDeTemps();
        if (vo == null)
        {
            vo = validarST.createDefaultVO();
        }
        validarST.validar(vo);
        return vo;
    }
    
    /**
     * Mtode per obtenir un "digest" SHA-1 de un byte[] de dades.
     * 
     * @param buf  dades a obtenir el digest.
     * @return byte[] amb el digest SHA-1 de les dades
     * @ejb.interface-method view-type="all"
     */
    public byte[] getDigest(byte [] buf)
    {
        try
        {
            MessageDigest sha = MessageDigest.getInstance("SHA-1");
            sha.update(buf);
            return sha.digest();
       }
        catch (NoSuchAlgorithmException e)
        {
            throw new RuntimeException(e);
        }

    }
}
